
/*
 * $Id: CltOpts.h,v 1.4 1999/05/28 22:25:49 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef CLT_OPTS
#define CLT_OPTS

#include "opts.h"
#include "WorldOpts.h"

// client options
class CltOpts: public OptGrp {
	public:
		CltOpts(); // defaults

		virtual bool validate() const;

	public:
		NetAddrOpt theOrgAddr;
		NetAddrOpt thePxyAddr;

		WorldOpts theWorld;

		TwoIntOpt thePorts;
		IntOpt theConnPoolCap;
		BoolOpt adjustConnPoolSize;
		DistrOpt theConnEstTimeout;
		TimeOpt theLaunchWin;
		TimeOpt theCoolPhase;

		IntOpt theRobotCnt;
		//IntOpt theReqCcl;
		RateOpt theReqRate;
		BoolOpt maximizeReqRate;

		BoolOpt ignoreFalseHits;
		BoolOpt printFalseMisses;
		BoolOpt doIOs;
};

extern CltOpts TheCltOpts;

#endif
