
/*
 * $Id: ObjLifeCycle.h,v 1.4 1999/05/04 04:48:59 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef OBJECT_LIFE_CYCLE_H
#define OBJECT_LIFE_CYCLE_H

class ObjTimes;

// models object modification and expected expiration times
class ObjLifeCycle {
	public:
		ObjLifeCycle();
		~ObjLifeCycle();

		const RndDistr *modTime() const { return theModTime; }
		const RndDistr *nowExpTime() const { return theNowExpTime; }
		const RndDistr *modExpTime() const { return theModExpTime; }

		void bday(RndDistr *aDistr);
		void modVar(double aVar);
		void modTime(RndDistr *aDistr, double aRatio);
		void nowExpTime(RndDistr *aDistr, double aRatio);
		void modExpTime(RndDistr *aDistr, double aRatio);

		void calcTimes(int oid, ObjTimes &times);

	protected:
		int lmtDelta(int oid, int cycleCnt, int cycleLen);

	protected:
		RndGen theRng;
		RndDistr *theBday;
		RndDistr *theModTime;
		RndDistr *theNowExpTime;
		RndDistr *theModExpTime;

		double theModVar;        // "variation" in lmt
		double theShowModRatio;  // how many objs know their mod time
		double theNowExpRatio;   // how many objs use (now+delta) model
		double theModExpRatio;   // how many objs use (mod+delta) model

		double theShowExpRatio;  // (1 - nowBased - modBased), cached
};

#endif
