
/*
 * $Id: ObjTimes.h,v 1.1 1999/04/30 04:43:21 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef OBJECT_TIMESTAMPS_H
#define OBJECT_TIMESTAMPS_H

class ObjLifeCycle;

// holds various object (entity) timestamps
class ObjTimes {
	friend ObjLifeCycle;

	public:
		ObjTimes() { reset(); }

		void reset();

		Time lmt() const { return theLmt; }
		Time exp() const { return theExp; }
		bool showLmt() const { return doShowLmt; }
		bool knownExp() const { return theExp >= 0; }

	protected:
		Time theLmt;
		Time theExp;
		bool doShowLmt;
};

#endif
