
/*
 * $Id: RndPermut.h,v 1.1 1999/05/26 19:03:24 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef PG_RANDOM_PERMUTATION_H
#define PG_RANDOM_PERMUTATION_H

#include "LibInit.h"

// We often need to convert a number to some uncorrellated uniformly
// distributed random number. Using seed-and-trial approach with a r.n.g. 
// does not work well if input stream of numbers is sequential and long.
// The permutator is also useful for seeding a r.n.g.

// Note: current permutation allows for a given [small] number of 
// high quality random values. The size of the output set is a parameter.

// changes the permutation set; expensive; 
// can be called multiple times, any time
// using prime numbers for set size is recommended
extern void RndPermutConfig(int setSize, int seed = 1);

// set size remains unchanged, but contents changes
extern void RndPermutSeed(int seed);

// use second parameter if you need to map two numbers into one uniform var
extern int RndPermut(int n, int m = 0);

LIB_INITIALIZER(RndPermutfInit)

#endif
