
/*
 * $Id: polyErrors.h,v 1.3.4.1 1999/06/15 23:19:29 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef POLY_ERRORS_H
#define POLY_ERRORS_H

#include "ErrorMgr.h"

// handles custom errors
class PolyErrMgr: public ErrorMgr {
	public:
		PolyErrMgr(); // defaults

		virtual const char *explStr(int e) const;

	protected:
		Array<const char *> theExpls;   // custom error strings
};

enum PolyErrors {
	errStart = 255,
	errForeignReq,
	errForeignRep,
	errPrematureEof,
	errPrematureEoh,
	errNoCLen,
	errHugeHdr,
	errUnchbHit,
	err1UseHit,
	errZeroFDLimit,
	errChbChange,
	errFalseHit,
	errServerGone,
	errLogBufFull,
	errBadRPort,
	errRPortOutOfRange,
	errRPortUsedTwice,

	errEnd
};

#endif
