
/*
 * $Id: logTags.cc,v 1.1.1.4 1999/02/21 06:30:33 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "String.h"
#include "Array.h"
#include "OLog.h"
#include "LogMeta.h"
#include "logTags.h"

static inline
OLog &operator <<(OLog &log, const LogTagDescr *d) { d->store(log); return log; }


// order is not important
void StoreSymbTable(OLog &log) {
	Array<LogTagDescr*> table;
	table
		<< new LogTagDescr(lgPrg, lpPrg, "_progress")
		<< new LogTagDescr(lgSymbTable, lpSymbTable, "_symb_table")
		<< new LogTagDescr(lgComment, lpComment, "_comment")
		<< new LogTagDescr(lgRunId, lpUniqId, "_run_id")

		<< new LogTagDescr(lgStatPing, lpStatPing, "i", 1)
		<< new LogTagDescr(lgStatSoft, lpStatSoft, "s")
		<< new LogTagDescr(lgStatPhaseWarm, lpStatPhase, "p-warm", 1)
		<< new LogTagDescr(lgStatPhaseMeas, lpStatPhase, "p-meas", 1)
		<< new LogTagDescr(lgStatPhaseCool, lpStatPhase, "p-cool", 1)
		;

	log << bege(lgSymbTable) << table << ende;

	while (table.count()) delete table.pop();
}
