
/*
 * $Id: NetDouble.cc,v 1.3 1999/06/02 02:18:36 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "xstd.h"

#include <math.h>
#include <iostream.h>
#include <stdlib.h>

#include "Assert.h"
#include "NetDouble.h"


NetDouble::NetDouble(double x) {
	mnt = (int) floor(0x7fffffff * frexp(x, &exp));
}

NetDouble::operator double() const {
	// avoid floating point exceptions on overflows when we read
	// invalid data
	return abs(exp) <= 1024 ? ldexp(mnt/(double)0x7fffffff, exp) : -1;
}
